%  Shaky v2.0      Copyright (C) 1998, Ken Kaneiwa (kaneiwa@jaist.ac.jp) 
:- module(sort,[]).

/* $B=R8l$N0z?t$r<h$j=P$9(B */
select_arg(TX1,LVL,TXX1,T1,Pro):-
	select_arg1(TX1,LVL,[],TXX1,T1,0,Pro).

select_arg1([],_,TMP,TMP,_,1,Pro).
select_arg1([],LVL,TMP,TMP,[VX,SORT,[]],0,0):- /*$B0z?t$NJd=<(B*/
	db:label([_,[LVL,SORT]]),
	bb_get(var_no,V),
	VX is V+1,
        bb_put(var_no,VX).
select_arg1([],LVL,TMP,TMP,[0,SORT,[]],0,1):- /*$B0z?t$NJd=<(B*/
	db:label([_,[LVL,SORT]]).
select_arg1([[LVL,T]|TX],LVL,TMP,Res,T,0,Pro):-
	select_arg1(TX,LVL,TMP,Res,T,1,Pro).
select_arg1([[LVL1,TT]|TX],LVL2,[],Res,T,S,Pro):-
	user:append([],[[LVL1,TT]],E),
	select_arg1(TX,LVL2,E,Res,T,S,Pro).
select_arg1([[LVL1,TT]|TX],LVL2,TMP,Res,T,S,Pro):-
	user:append(TMP,[[LVL1,TT]],E),
	select_arg1(TX,LVL2,E,Res,T,S,Pro).

/* $BC10l2==hM}(B */
/* T1,T2:terms,ARG:argument structure */
unify(T1,T2,ARG,P,TMP,R):-
	unify_sub(T1,T2,ARG,P,TMP,R).

unify_sub(_,[],[],_,TMP,TMP).
unify_sub(TX1,TX2,[[LVL,_]|ARG],[Pred,Pro],TMP,R):-
	select_arg(TX1,LVL,TXX1,T1,Pro),
	select_arg(TX2,LVL,TXX2,T2,Pro),!,
	unify_sub2(T1,T2,TMP,E),
	unify_sub(TXX1,TXX2,ARG,[Pred,Pro],E,R).

/* $B#10z?t!J9`!K$NC10l2=(B */
/* $BJQ?t$,4XO"$E$1$i$l$F$$$k>l9g(B */
unify_sub2(T1,T2,TMP,TMP):-
	corefer(TMP,T1,RES),
	T1 \== RES,!,
	T2 == RES.
unify_sub2(T1,T2,TMP,E):-  /* $BJQ?t$,4XO"$E$1$i$l$F$J$$>l9g(B */
	corefer(TMP,T1,RES1),
	T1 == RES1,
	unify1(T1,T2,RES),
	user:append(TMP,[[T1,RES]],E).

sit_var([S,[P,T,1],TP],[],[S,[P,T,1],TP]).
sit_var([S,[P,T,1],TP],[[S,S2]|SS],[RS,[P,T,1],TP]):-
	!,sit_var([S2,[P,T,1],TP],SS,[RS,[P,T,1],TP]).
sit_var([S,[P,T,1],TP],[[S1,S2]|SS],[RS,[P,T,1],TP]):-
	S \== S1,
	sit_var([S,[P,T,1],TP],SS,[RS,[P,T,1],TP]).

/* $BJQ?t$NJQ49MzNr$K=>$C$F!"F1$8JQ?t$rJQ49$9$k(B */
corefer([],TX1,TX1).
corefer([[T1,T2]|TMPX],T1,RES):-
	!,corefer(TMPX,T2,RES).
corefer([[T1,T2]|TMPX],TX1,RES):-
	T1 \== TX1,
	corefer(TMPX,TX1,RES).

corefer0(TMP1,[],TMP2,TMP2).
corefer0(TMP1,[[LVL,T]|TX],TMP2,RES):-
	corefer(TMP1,T,TT),
	user:append(TMP2,[[LVL,TT]],E),
	corefer0(TMP1,TX,E,RES).

/* $B9`$N7?JQ49(B */
unify1(T,T,T).
unify1([V1,X,ARG],[V2,X,ARG],[V2,X,ARG]):-
	V1 \== 0,
	V2 \== 0.
unify1([V1,X1,ARG1],[V2,X2,ARG2],[V2,X,ARG]):-
	ARG1 \== ARG2,!,
	arg_unify(V1,ARG1,V2,ARG2,[],RESULT),
	unify1([V1,X1,RESULT],[V2,X2,RESULT],TT).
unify1([V1,X1,ARG],[V2,X2,ARG],TT):-
	sort_unify([V1,X1,ARG],[V2,X2,ARG],TT).

arg_unify(_,[],_,[],TMP,TMP).
arg_unify(V1,ATTS1,V2,[A|ATTS2],TMP,ARG):-
	V1 \== 0,
	select_att(A,ATTS1,RT,[],REST),
	user:append(TMP,RT,TMP2),
	arg_unify(V1,REST,V2,ATTS2,TMP2,ARG).
arg_unify(V1,[A|ATTS1],0,ATTS2,TMP,ARG):-
	select_att(A,ATTS2,RT,[],REST),
	user:append(TMP,RT,TMP2),
	arg_unify(V1,ATTS1,0,REST,TMP2,ARG).

select_att([L1,T1],[],[L1,T1],TMP,TMP).
select_att([L1,T1],[[L1,T1]|ATTS2],[L1,T1],TMP,REST):-
	user:append(TMP,ATTS2,REST).
select_att([L1,T1],[[L1,T2]|ATTS2],[L1,TT],TMP,REST):-
	T1 \== T2,
	unify1(T1,T2,TT),
	user:append(TMP,ATTS2,REST).
select_att([L1,T1],[[L2,T2]|ATTS2],[L1,T1],TMP,ATTS):-
	L1 \== L2,
	user:append(TMP,[[L2,T2]],TMP2),
	select_att([L1,T1],ATTS2,TMP2,ATTS).

sort_unify(T,T,T).
sort_unify([V1,X,ARG],[V2,X,ARG],[V2,X,ARG]):-
	V1 \== 0,
	V2 \== 0.
sort_unify(T1,T2,RES):-
	T1 \== T2,
	type_change1(T1,T2,TT),
	sort_unify(TT,T2,RES).
sort_unify(T1,T2,RES):-
	T1 \== T2,
	type_change2(T2,T1,TT),
	sort_unify(T1,TT,RES).

/* $B0z?t$NJd=<(B */

add_arg([],ARG,TMP,TMP).
add_arg([T|T1],ARG,TMP,ARG1):-
	add_arg1(T,ARG,TMP,TMP2),
	add_arg(T1,ARG,TMP2,ARG1).

add_arg1([LABL,_],[],TMP,E):-
	db:label([_,[LABL,SORT]]),
	user:append(TMP,[[LABL,SORT]],E).
add_arg1([LABL,_],[[LABL,_]|ARGS],TMP,TMP).	
add_arg1([LABL1,T],[[LABL2,_]|ARGS],TMP,E):-
	LABL1 \== LABL2,
	add_arg1([LABL1,T],ARGS,TMP,E).


/* $B%U%!%/%H$K$h$k%5%V%4!<%k$N>ZL@(B */
/* P:predicate=[rel,0/1],T1:terms */
/*resolve([S,[P,T1,1],_],TMP,R):-
	db:fact([_,[S,[P,T2,1],_]]),
	db:arg([_,[P,ARG]]),
	unify(T1,T2,ARG,P,TMP,R).
*/

resolve([[0,S],[P,T1,1],TP],TMP,R,TMP3,TMP3):- /* $BDj?t$HDj?t(B */
	sit_var([[0,S],[P,T1,1],TP],TMP3,[S1,[P,T1,1],TP]),
	sit_rule1([S1,[P,T2,1],TP],[S2,[P,T2,1],TP]),
	db:arg([_,[P,ARG]]),
	add_arg(T1,ARG,ARG,ARG1),
	unify(T1,T2,ARG1,P,TMP,R).
resolve([[V,S],[P,T1,1],TP],TMP,R,TMP3,R3_S):- /* $BJQ?t$H!)!)(B */
        V \== 0,
	sit_var([[V,S],[P,T1,1],TP],TMP3,[S1,[P,T1,1],TP]),
	sit_rule5([S1,[P,T2,1],TP],[S2,[P,T2,1],TP]),
	user:append(TMP3,[[S1,S2]],R3_S),
	db:arg([_,[P,ARG]]),
	add_arg(T1,ARG,ARG,ARG1),
	unify(T1,T2,ARG1,P,TMP,R).
resolve([S,[P,T1,1],TP],TMP,R,TMP3,TMP3):- /* $BDj?t$HJQ?t(B */
	sit_var([S,[P,T1,1],TP],TMP3,[S1,[P,T1,1],TP]),
	sit_rule3([S1,[P,T2,1],TP],[S2,[P,T2,1],TP]),
	db:arg([_,[P,ARG]]),
	add_arg(T1,ARG,ARG,ARG1),
	unify(T1,T2,ARG1,P,TMP,R).

/* $B?dO@5,B'#2@lMQ(B*/
resolve1([[0,S],[P,T1,1],TP],TMP,R,TMP3,TMP3):- /* $BDj?t$HDj?t(B */
	sit_var([[0,S],[P,T1,1],TP],TMP3,[S1,[P,T1,1],TP]),
	sit_rule1([S1,[P,T2,1],TP],[S2,[P,T2,1],TP]),
	db:arg([_,[P,ARG]]),
	unify(T1,T2,ARG,P,TMP,R).
resolve1([[V,S],[P,T1,1],TP],TMP,R,TMP3,R3_S):- /* $BJQ?t$H!)!)(B */
        V \== 0,
	sit_var([[V,S],[P,T1,1],TP],TMP3,[S1,[P,T1,1],TP]),
	sit_rule5([S1,[P,T2,1],TP],[S2,[P,T2,1],TP]),
	user:append(TMP3,[[S1,S2]],R3_S),
	db:arg([_,[P,ARG]]),
	unify(T1,T2,ARG,P,TMP,R).
resolve1([S,[P,T1,1],TP],TMP,R,TMP3,TMP3):- /* $BDj?t$HJQ?t(B */
	sit_var([S,[P,T1,1],TP],TMP3,[S1,[P,T1,1],TP]),
	sit_rule3([S1,[P,T2,1],TP],[S2,[P,T2,1],TP]),
	db:arg([_,[P,ARG]]),
	unify(T1,T2,ARG,P,TMP,R).


sit_rule5([[V,S],[P,T2,1],TP],[[V1,S1],[P,T2,1],TP]):-
	V \== 0,
	db:fact([_,[[V1,S1],[P,T2,1],TP]]).
/* $B>u67$,JQ?t$G$"$k%U%!%/%H$rC5$9(B */
sit_rule3([[0,S],[P,T2,1],TP],[[0,S],[P,T2,1],TP]):-
	db:fact([_,[[V,_],[P,T2,1],TP]]),
	V \== 0.
/* driven$BMQ$N>u674V5,B'$NE,MQ(B */
sit_rule4([[0,S],[P,T1,1],TP],[[0,S],[P,T2,1],TP]).
sit_rule4([[0,S],[P,T1,1],TP],[[V,_],[P,T2,1],TP]):-
	V \==0.
sit_rule4([[0,S],[P,T1,1],0],[[0,S2],[P,T2,1],0]):-
	db:sit([_,[SS,S]]),
        sit_rule4([[0,SS],[P,T1,1],0],[[0,S2],[P,T2,1],0]).
sit_rule4([[0,S],[P,T1,1],2],[[0,S2],[P,T2,1],2]):-
	db:sit([_,[S,SS]]),
        sit_rule4([[0,SS],[P,T1,1],2],[[0,S2],[P,T2,1],2]).

/* $B>u674V4X785,B'$rE,MQ$7$F%U%!%/%H$rC5$9(B */
sit_rule1([[0,S],[P,T2,1],TP],[[0,S],[P,T2,1],TP]):-
        db:fact([_,[[0,S],[P,T2,1],TP]]).
sit_rule1([[0,S],[P,T2,1],0],[[0,S2],[P,T2,1],0]):-
	db:sit([_,[SS,S]]),
        sit_rule1([[0,SS],[P,T2,1],0],[[0,S2],[P,T2,1],0]).
sit_rule1([[0,S],[P,T2,1],2],[[0,S2],[P,T2,1],2]):-
	db:sit([_,[S,SS]]),
        sit_rule1([[0,SS],[P,T2,1],2],[[0,S2],[P,T2,1],2]).

/* $B>u674V4X785,B'$rE,MQ$7$F%k!<%k$rC5$9(B */
sit_rule2([[0,S],[P,T2,1],TP],[[0,S],[P,T2,1],TP],BODY):-
	db:rules([_,[_,[[[0,S],[P,T2,1],TP],BODY,_]]]).
sit_rule2([[0,S],[P,T2,1],0],[[0,S2],[P,T2,1],0],B):-
	db:sit([_,[SS,S]]),
        sit_rule2([[0,SS],[P,T2,1],0],[[0,S2],[P,T2,1],0],B).
sit_rule2([[0,S],[P,T2,1],2],[[0,S2],[P,T2,1],2],B):-
	db:sit([_,[S,SS]]),
        sit_rule2([[0,SS],[P,T2,1],2],[[0,S2],[P,T2,1],2],B).


	

/* $BC10l2=A0$N%j%M!<%_%s%0(B */
/*
	renaming(T1,T2,[],RES_R,[],RES_T1),

renaming([],_,TMP1,TMP1,TMP2,TMP2).
renaming([T1|TX1],TX2,TMP1,RES1,TMP2,RES2):-
	corefer(TMP1,T1,RES_T1),
	renaming1(RES_T1,TX2,TMP1,RES_TMP,RES_T),
	user:append(TMP2,RES_T,E),
	renaming(TX1,TX2,RES_TMP,RES1,E,RES2).
renaming1(T1,[],TMP,TMP,T1).
renaming1([LVL1,[V1,X1,ARG1]],[[LVL2,[V1,X2,ARG2]]|TX2],TMP,RES_TMP,[VX,X1,ARG1]):-
	LVL1 \== LVL2,
	V1 \== 0,
	bb_get(var_no,NV),
	VX is NV+1,
        bb_put(var_no,VX),
	appned(TMP,[[[V1,X1,ARG1],[VX,X1,ARG1]]],RES_TMP).
renaming1(T1,[T2|TX2],TMP,RES_TMP,RES_T):-
	renaming1(T1,TX2,TMP,RES_TMP,RES_T).
*/

renaming([S,[P,ARGS,POL],T],TMP1,[S,[P,R_ARGS,POL],T],TMP2,R):-
	renaming1(ARGS,TMP1,R_ARGS,TMP2,R).

/* TMP1$B$O0z?t$N%j%M!<%`$K$h$k:F9=C[(B */
renaming1([],TMP1,TMP1,TMP2,TMP2).
renaming1([[LVL,T1]|TX],TMP1,RES1,TMP2,RES2):-
	corefer(TMP2,T1,T),
	T1 \== T,
	user:append(TMP1,[[LVL,T]],E),
	renaming1(TX,E,RES1,TMP2,RES2).
renaming1([[LVL,[V,X,ARG]]|TX],TMP1,RES1,TMP2,RES2):-
	V == 0,
	user:append(TMP1,[[LVL,[V,X,ARG]]],E),
	renaming1(TX,E,RES1,TMP2,RES2).
renaming1([[LVL,[V,X,ARG]]|TX],TMP1,RES1,TMP2,RES2):-
	V \== 0,
	bb_get(var_no,NV),
	VX is NV+1,
        bb_put(var_no,VX),
	user:append(TMP1,[[LVL,[VX,X,ARG]]],E1),
	user:append(TMP2,[[[V,X,ARG],[VX,X,ARG]]],E2),
	renaming1(TX,E1,RES1,E2,RES2).

/* $B7?JQ49(B */
type_change1([V,Y,ARG],[V2,Z,ARG1],[V,X,ARG]):-
	V \==0,
	V2 \==0,
	db:sort([_,[X,Y]]).
type_change1([V,Y,ARG],[0,_,ARG1],[0,X,ARG]):-
	V \== 0,
        db:sort([_,[X,Y]]).
type_change1([V,Y,ARG],[0,Y,ARG1],[0,Y,ARG]):-
	V \== 0.
type_change1([V,top,ARG],[V2,Z,ARG1],[V,Z,ARG]):-
	V \== 0,
	V2 \== 0.
type_change1([V,top,ARG],[0,Z,ARG1],[0,Z,ARG]):-
	V \== 0.
type_change2([0,Y,ARG],[0,_,ARG1],[0,X,ARG]):-
	db:sort([_,[X,Y]]).
type_change2([0,Y,ARG],[V2,_,ARG1],[V2,X,ARG]):-
	V2 \== 0,
	db:sort([_,[X,Y]]).
type_change2([0,Y,ARG],[V2,Y,ARG1],[V2,Y,ARG]):-
	V2 \== 0.

/* $B?dO@5,B'(B */
/* $B=R8l$N!c4X78(B */
reasoning_rule1([S,[[PY,0],T,1],TP],[S,[[PX,0],T,1],TP]):-
	db:imp([_,[[PX,0],[PY,0]]]).
reasoning_rule1([S,[[PY,1],T,1],TP],[S,[[PX,1],T,1],TP]):-
	db:imp([_,[[PX,0],[PY,0]]]).

/* $B=R8l$N(Bmeet$B4X78(B */
reasoning_rule2([S,[[PX,0],T,1],TP],[S,[[PY1,0],T,1],TP],[S,[[PY2,0],T,1],TP]):-
	db:imp([_,[[PX,0],[PY1,0]]]),
	db:imp([_,[[PX,0],[PY2,0]]]),
	PY1 \== PY2,
	\+db:sit([_,[_,S]]).
reasoning_rule2([S,[[PX,1],T,1],TP],[S,[[PY1,1],T,1],TP],[S,[[PY2,1],T,1],TP]):-
	db:imp([_,[[PX,0],[PY1,0]]]),
	db:imp([_,[[PX,0],[PY2,0]]]),
	PY1 \== PY2.

/* $B%k!<%k$K$h$kF3=P=hM}(B */
/* $B%k!<%k$N>ZL@$O%X%C%IIt$h$j%k!<%k$rA*$s$G!"%\%G%#It$r>ZL@$9$k!#(B
   $B$=$N%\%G%#It$K$h$kC10l2=$r%X%C%IIt$KE,MQ$9$k(B */

driven0([S,[P,T1,1],TP],TMP3,R3_S):-
	db:rules([_,[_,[[[V,S1],[P,T2,1],TP],BODY,_]]]),
	V \== 0,
	query0(BODY,[],R1,[],R2,[],R3_S), 
	db:arg([_,[P,ARG]]),
	add_arg(T1,ARG,ARG,ARG1),	
	renaming([[V,S1],[P,T2,1],TP],[],[[V2,S2],[P2,R_T2,POL],TT2],R2,R3),
	corefer0(R3,R_T2,[],RR_T2), /* BODY$B$NJQ99$r(BHEAD$B$KH?1G(B */
	sit_var([[V2,S2],[P,RR_T2,1],TP],R3_S,[[V3,S3],[P,RR_T2,1],TP]),
	corefer0(R1,RR_T2,[],RRR_T2), /* BODY$B$NJQ99$r(BHEAD$B$KH?1G(B */
	sit_rule4([S,[P,T1,1],TP],[[V3,S3],[P,RRR_T2,1],TP]),
	unify(T1,RRR_T2,ARG1,P,[],RES).
driven0([[V,S],[P,T1,1],TP],TMP3,R3_S):-
	db:rules([_,[_,[[[V1,S1],[P,T2,1],TP],BODY,_]]]),
	V \== 0,
	query0(BODY,[],R1,[],R2,[],R3_S), 
	db:arg([_,[P,ARG]]),
	add_arg(T1,ARG,ARG,ARG1),
	renaming([[V1,S1],[P,T2,1],TP],[],[[V2,S2],[P2,R_T2,POL],TT2],R2,R3),
	corefer0(R3,R_T2,[],RR_T2), /* BODY$B$NJQ99$r(BHEAD$B$KH?1G(B */
	sit_var([[V2,S2],[P,RR_T2,1],TP],R3_S,[[V3,S3],[P,RR_T2,1],TP]),
	corefer0(R1,RR_T2,[],RRR_T2), /* BODY$B$NJQ99$r(BHEAD$B$KH?1G(B */
	unify(T1,RRR_T2,ARG1,P,[],RES).
driven0([[0,S],[P,T1,1],TP],TMP3,R3_S):-
	sit_rule2([[0,S],[P,T2,1],TP],[[0,SS],[P,T2,1],TP],BODY),
	query0(BODY,[],R1,[],R2,[],R3_S), 
	db:arg([_,[P,ARG]]),
	add_arg(T1,ARG,ARG,ARG1),
	renaming([[0,SS],[P,T2,1],TP],[],[[0,S2],[P2,R_T2,POL],TT2],R2,R3),
	corefer0(R3,R_T2,[],RR_T2), /* BODY$B$NJQ99$r(BHEAD$B$KH?1G(B */
	corefer0(R1,RR_T2,[],RRR_T2), /* BODY$B$NJQ99$r(BHEAD$B$KH?1G(B */
	unify(T1,RRR_T2,ARG1,P,[],RES).

/*	corefer0(R_T2,T1,[],RR_T2), */
/*	unify(T1,RR_T2,ARG,P,R1,RES). */
/* $B$3$N;~E@$G%X%C%IIt$N(BS$B$H(BP$B$O0lCW$7$F$$$k(B */
/* driven1([S,[P,T1,1],_]):-
	db:rules([_,[_,[[S,[P,T2,1],T],BODY,_]]]),
	query1(BODY,[],R1,[],R2),
	db:arg([_,[P,ARG]]),
	renaming([S,[P,T2,1],T],[],[S2,[P2,R_T2,POL],TT2],R2,R3),
	corefer(R_T2,R1,RR_T2),
	unify(T1,RR_T2,ARG,P,R1,RES).*/

/* $B?dO@5,B'#2$K$h$k<ALd:Q$_=R8l$NMzNr(B */
trace_wt([S,[P,T1,1],TP],TRACE,RESULT):-
	user:append(TRACE,[P],RESULT).

trace_check(P,[]).
trace_check(P,[T|TRACE]):-
	P \== T,
	trace_check(P,TRACE).

/* $B%4!<%k@a(B|($B#1$D$NL?Bj(B)$B$N>ZL@(B */
/* $B?dO@5,B'#1(B($B=R8l$N!c4X78(B)$B$r;H$C$?>ZL@(B */
query_sub([S,[P,T1,1],TP],TMP,R,TRACE,TMP3,R3_S):-
	trace_check(P,TRACE),
	query_sub0([S,[P,T1,1],TP],TMP,R,TRACE,TMP3,R3_S).

query_sub_rule2(Prop,TMP,R,TRACE,TMP3,R3_S):-
	sit_var(Prop,TMP3,Prop1),
	resolve1(Prop1,TMP,R,TMP3,R3_S).

query_sub0(Prop,TMP,R,TRACE,TMP3,R3_S):-
	sit_var(Prop,TMP3,Prop1),
	resolve(Prop1,TMP,R,TMP3,R3_S).
query_sub0(Prop,_,[],TRACE,TMP3,R3_S):-
	sit_var(Prop,TMP3,Prop1),
	driven0(Prop1,TMP3,R3_S).
query_sub0(Prop,TMP,R,TRACE,TMP3,TMP3):-
	reasoning_rule1(Prop,Prop2),
	query_sub(Prop2,[],R,TRACE,[],R3_S).
query_sub0(Prop,TMP,R,TRACE,TMP3,TMP3):-
	trace_wt(Prop,TRACE,RESULT),
	reasoning_rule2(Prop,Prop2,Prop3),
	query_sub_rule2(Prop2,[],R1,RESULT,[],R31),
	query_sub_rule2(Prop3,R1,R,RESULT,[],R32).

/* $B?dO@5,B'#2(B($B=R8l$N(Bmeet$B4X78(B)$B$r;H$C$?>ZL@(B */
/*query_sub1(Prop,TMP,R):-
	resolve(Prop,TMP,R).
query_sub1(Prop,_,[]):-
	driven1(Prop).
query_sub1(Prop,TMP,R):-
	reasoning_rule2(Prop,Prop2,Prop3),
	query_sub1(Prop2,[],R1),
	query_sub1(Prop3,R1,R).
*/
/* $B<ALd$N3+;O(B $B!J$3$3$G#2$D$N?dO@5,B'$r;H$&J}?K$rA*Br!K(B*/
query(PX):-
	bb_put(var_no,1), /* $BJQ?t@8@.$N=i4|2=(B */
	query0(PX,[],R1,[],R2,[],R3_S).
/*query(PX):-
	bb_put(var_no,1),
	query1(PX,[],R1,[],R2).*/

/* $B<ALd$N3+;O(B */
query_start([[S,[P,ARG,POL],ST]]):-
	\+db:arg([_,[P,_]]),   /* $B<ALd$N=R8l$N0z?t9=@.$,%G!<%?%Y!<%9$K$J$$(B */
	db:new_id(arg_id,Id),
	assert(db:arg([Id,[P,[]]])),
	bb_put(del_tmp,Id),
	bb_put(id_tmp,-1),
	bb_put(add_tmp,[Id,[P,LX]]),
	db:store_arg1(ARG,P,Id,[]),
	query([[S,[P,ARG,POL],ST]]).
query_start([[S,[P,ARG,POL],ST]]):-
	db:arg([Id,[P,LX]]),
	bb_put(del_tmp,Id),
	bb_put(id_tmp,nil),
	bb_put(add_tmp,[Id,[P,LX]]),
	db:store_arg1(ARG,P,Id,LX), /* $B0z?t$NDI2C(B */
	query([[S,[P,ARG,POL],ST]]).

/* $B%4!<%k@a!JL?Bj$N@Q!K$r>ZL@(B */
/* TMP1:$B$=$l$^$G$N7?JQ49MzNr(B,R1:$BJQ997k2L(B */
/* TMP2:$B$=$l$^$G$NJQ49L>MzNr(B,R2:$BJQ997k2L(B */
query0([P|[]],TMP1,R1,TMP2,R2,TMP3,R3_S):-
	renaming(P,[],R_P,TMP2,R2),
	!,query_sub(R_P,TMP1,R1,[],TMP3,R3_S).
query0([P|PX],TMP1,R1,TMP2,R2,TMP3,R3_S):-
	renaming(P,[],R_P,TMP2,R22),	
	!,query_sub(R_P,TMP1,R11,[],TMP3,R31_S),
	query0(PX,R11,R1,R22,R2,R31_S,R3_S).
/* query1([P|[]],TMP1,R1,TMP2,R2):-
	renaming(P,[],R_P,TMP2,R2),
	!,query_sub1(R_P,TMP1,R1).
query1([P|PX],TMP1,R1,TMP2,R2):-
	renaming(P,[],R_P,TMP2,R22),	
	!,query_sub1(R_P,TMP1,R11),
	query1(PX,R11,R1,R22,R2).
*/
/* $B%G%P%C%/MQ=R8l(B */
tr_etoi(Ex,Result):-
	tr:remove_ctl(Ex,[9,10,32],String),
	tr:morpheme_analysis(String,Result,['#',:,-,=,<,>,'(',')',',','|','.','[',']']).

inp(In,Res,Out):-
	name(In,Ex),
	tr_etoi(Ex,Res),
        tr:parse(Res,Out).

inp2(In,Res,Out,Out2):-
	name(In,Ex),
	tr_etoi(Ex,Res),
        tr:parse(Res,Out),
        tr:v_replace(Out,Out2).

inpm(In,Res,Out,TMP,T):-
	name(In,Ex),
	tr_etoi(Ex,Res),
        tr:parse(Res,Out),
        uni2(Out,TMP,T).

uni2([_,[S,[P,T1,1],_]],TMP,T):-
	select_arg(T1,sbj,[],TMP,T,0,0).
